// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "AdoRecordsetView.h"
#include "ChildView.h"
#include <math.h>

IMPLEMENT_DYNCREATE( CAdoDataCell, CExtGridCellVariant );
IMPLEMENT_DYNCREATE( CAdoDataCell_Combobox, CExtGridCellComboBox );

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNAMIC( CAdoDataProvider, CExtGridDataProviderRecordset );

/////////////////////////////////////////////////////////////////////////////
// CChildView

CChildView::CChildView()
{
}

CChildView::~CChildView()
{
}

BEGIN_MESSAGE_MAP( CChildView, CExtGridWnd )
	//{{AFX_MSG_MAP(CChildView)
	ON_WM_CREATE()
	ON_WM_VSCROLL()
	ON_COMMAND(ID_CMD_FIT_ALL_COLUMNS, OnCmdFitAllColumns)
	ON_UPDATE_COMMAND_UI(ID_CMD_FIT_ALL_COLUMNS, OnUpdateCmdFitAllColumns)
	ON_COMMAND(ID_CMD_NAVIGATE_TOP, OnCmdNavigateTop)
	ON_UPDATE_COMMAND_UI(ID_CMD_NAVIGATE_TOP, OnUpdateCmdNavigateTop)
	ON_COMMAND(ID_CMD_NAVIGATE_BOTTOM, OnCmdNavigateBottom)
	ON_UPDATE_COMMAND_UI(ID_CMD_NAVIGATE_BOTTOM, OnUpdateCmdNavigateBottom)
	ON_COMMAND(ID_CMD_NAVIGATE_PAGE_UP, OnCmdNavigatePageUp)
	ON_UPDATE_COMMAND_UI(ID_CMD_NAVIGATE_PAGE_UP, OnUpdateCmdNavigatePageUp)
	ON_COMMAND(ID_CMD_NAVIGATE_PAGE_DOWN, OnCmdNavigatePageDown)
	ON_UPDATE_COMMAND_UI(ID_CMD_NAVIGATE_PAGE_DOWN, OnUpdateCmdNavigatePageDown)
	ON_COMMAND(ID_CMD_NAVIGATE_FOCUS, OnCmdNavigateFocus)
	ON_UPDATE_COMMAND_UI(ID_CMD_NAVIGATE_FOCUS, OnUpdateCmdNavigateFocus)
	ON_COMMAND(ID_QUERY_ADO_SMALL, OnQueryAdoSmall)
	ON_UPDATE_COMMAND_UI(ID_QUERY_ADO_SMALL, OnUpdateQueryAdoSmall)
	ON_COMMAND(ID_CLOSE_ADO_RECORDSET_SMALL, OnCloseAdoRecordsetSmall)
	ON_UPDATE_COMMAND_UI(ID_CLOSE_ADO_RECORDSET_SMALL, OnUpdateCloseAdoRecordsetSmall)
	ON_COMMAND(ID_CMD_SHOW_GRID_LINES, OnCmdShowGridLines)
	ON_UPDATE_COMMAND_UI(ID_CMD_SHOW_GRID_LINES, OnUpdateCmdShowGridLines)
	ON_COMMAND(ID_CMD_SHOW_ROW_HEADERS, OnCmdShowRowHeaders)
	ON_UPDATE_COMMAND_UI(ID_CMD_SHOW_ROW_HEADERS, OnUpdateCmdShowRowHeaders)
	ON_COMMAND(ID_USE_DYNAMIC_COLUMN_RESIZING, OnUseDynamicColumnResizing)
	ON_UPDATE_COMMAND_UI(ID_USE_DYNAMIC_COLUMN_RESIZING, OnUpdateUseDynamicColumnResizing)
	ON_COMMAND(ID_USE_THUMB_TRACKING_HORIZONTAL, OnUseThumbTrackingHorizontal)
	ON_UPDATE_COMMAND_UI(ID_USE_THUMB_TRACKING_HORIZONTAL, OnUpdateUseThumbTrackingHorizontal)
	ON_COMMAND(ID_USE_THUMB_TRACKING_VERTICAL, OnUseThumbTrackingVertical)
	ON_UPDATE_COMMAND_UI(ID_USE_THUMB_TRACKING_VERTICAL, OnUpdateUseThumbTrackingVertical)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChildView message handlers

int CChildView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if( CExtPPVW < CExtGridWnd > :: OnCreate( lpCreateStruct ) == -1 )
	{
		ASSERT( FALSE );
		return -1;
	}
	m_wndScrollBarH.m_eSO = CExtScrollBar::__ESO_BOTTOM;
	m_wndScrollBarV.m_eSO = CExtScrollBar::__ESO_RIGHT;
	if( ! m_wndScrollBarV.Create(
			WS_CHILD|WS_VISIBLE|SBS_VERT|SBS_RIGHTALIGN,
			CRect(0,0,0,0),
			this,
			1
			)
		)
	{
		ASSERT( FALSE );
		return -1;
	}
	if( ! m_wndScrollBarH.Create(
			WS_CHILD|WS_VISIBLE|SBS_HORZ|SBS_BOTTOMALIGN,
			CRect(0,0,0,0),
			this,
			2
			)
		)
	{
		ASSERT( FALSE );
		return -1;
	}
	m_wndScrollBarH.SyncReservedSpace( &m_wndScrollBarV );
	m_wndScrollBarV.SyncReservedSpace( &m_wndScrollBarH );
	
	if( ! m_wndSliderV.Create(
			WS_CHILD|WS_VISIBLE|WS_CLIPSIBLINGS
				|TBS_VERT|TBS_BOTH|TBS_NOTICKS,
			CRect(0,0,1,80),
			this,
			3
			)
		)
	{
		ASSERT( FALSE );
		return -1;
	}
	m_wndScrollBarV.m_hWndAfter = m_wndSliderV.GetSafeHwnd();
	m_wndSliderV.SetRange( 4, 200 );
	m_wndSliderV.SetPos( DefaultRowHeightGet() );
	m_wndSliderV.SetLineSize( 1 );
	m_wndSliderV.SetPageSize( 0 );

	if(		(! m_wndToolbarHL.Create(
				NULL,
				this,
				4,
				WS_CHILD|WS_VISIBLE
					|CBRS_ALIGN_BOTTOM|CBRS_TOOLTIPS
					|CBRS_FLYBY|CBRS_SIZE_DYNAMIC
				) )
		|| (! m_wndToolbarHL.LoadToolBar(IDR_TOOLBAR_SMALL_ICONS_HORZ_LEFT) )
		)
	{
		ASSERT( FALSE );
		return -1;
	}
	m_wndToolbarHL.MoveWindow( 0, 0, 28, 1 );
	m_wndScrollBarH.m_hWndBefore = m_wndToolbarHL.GetSafeHwnd();

	if(		(! m_wndToolbarHR.Create(
				NULL,
				this,
				4,
				WS_CHILD|WS_VISIBLE
					|CBRS_ALIGN_BOTTOM|CBRS_TOOLTIPS
					|CBRS_FLYBY|CBRS_SIZE_DYNAMIC
				) )
		|| (! m_wndToolbarHR.LoadToolBar(IDR_TOOLBAR_SMALL_ICONS_HORZ_RIGHT) )
		)
	{
		ASSERT( FALSE );
		return -1;
	}
	m_wndToolbarHR.MoveWindow( 0, 0, 56, 1 );
	m_wndScrollBarH.m_hWndAfter = m_wndToolbarHR.GetSafeHwnd();

	if(		(! m_wndToolbarV.Create(
				NULL,
				this,
				5,
				WS_CHILD|WS_VISIBLE
					|CBRS_ALIGN_RIGHT|CBRS_TOOLTIPS
					|CBRS_FLYBY|CBRS_SIZE_DYNAMIC
				) )
		|| (! m_wndToolbarV.LoadToolBar(IDR_TOOLBAR_SMALL_ICONS_VERT) )
		)
	{
		ASSERT( FALSE );
		return -1;
	}
	m_wndToolbarV.MoveWindow( 0, 0, 1, 68 );
	m_wndScrollBarV.m_hWndBefore = m_wndToolbarV.GetSafeHwnd();

	GridLinesHorzSet( true, false );
	GridLinesVertSet( true, false );
	SiwModifyStyleEx(
		__EGBS_EX_CORNER_AREAS_3D|__EGBS_EX_CORNER_AREAS_CURVE,
		0L,
		false
		);
	EnableTooltips();
	EnableExpanding();
	BseModifyStyle(
		0L,
		__EGWS_BSE_DEFAULT,
		false
		);
	SiwModifyStyle(
		__EGBS_SFB_CELLS
			|__EGBS_RESIZING_CELLS_OUTER_H
			|__EGBS_RESIZING_CELLS_OUTER_V
			|__EGBS_FIXED_SIZE_ROWS
			//|__ESIS_DISABLE_THUMBTRACK_V
			|__ESIS_DISABLE_AUTOHIDE_SB,
		0L,
		false
		);
	SiwModifyStyleEx(
		__EGWS_EX_PM_COLORS,
		0,
		false
		);

/////////////////////////////////////////////////////////////////////////
// BEGIN: ADDED BY PROF-UIS TECH SUPPORT
BseModifyStyle( __EGWS_BSE_BUTTONS_PERSISTENT, 0, false );
// END: ADDED BY PROF-UIS TECH SUPPORT
/////////////////////////////////////////////////////////////////////////

	SiwScrollTypeHSet( __ESIW_ST_PIXEL, false );
	SiwScrollTypeVSet( __ESIW_ST_ITEM, false );
	ExternalDataSet( true );
	OuterRowCountTopSet( 1L, false );
	OuterColumnCountLeftSet( 1L, false );
	OuterColumnWidthSet( true, 0, 0 );
	OuterColumnCountRightSet( 1L, false );
	OuterColumnWidthSet( false, 0, 0 );
	return 0;
}

CScrollBar* CChildView::GetScrollBarCtrl(int nBar) const
{
	ASSERT_VALID( this );
	if( m_hWnd == NULL || (! ::IsWindow(m_hWnd) ) )
		return NULL;
	ASSERT( nBar == SB_HORZ || nBar == SB_VERT );
	if( nBar == SB_HORZ )
	{
		if( m_wndScrollBarH.GetSafeHwnd() != NULL )
			return ( const_cast < CExtScrollBar * > ( &m_wndScrollBarH ) );
	} // if( nBar == SB_HORZ )
	else
	{
		if( m_wndScrollBarV.GetSafeHwnd() != NULL )
			return ( const_cast < CExtScrollBar * > ( &m_wndScrollBarV ) );
	} // else from if( nBar == SB_HORZ )
	return NULL;
}

INT CChildView::DefaultRowHeightSet(
	INT nRowHeight,
	bool bRedraw // = true
	)
{
	if( nRowHeight < 4 )
		nRowHeight = 4;
	else if( nRowHeight > 200 )
		nRowHeight = 200;
INT nRetVal = CExtPPVW < CExtGridWnd > :: DefaultRowHeightSet( nRowHeight, bRedraw );
	if( nRowHeight != m_wndSliderV.GetPos() )
		m_wndSliderV.SetPos( nRowHeight );
	return nRetVal;
}

void CChildView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	if(		pScrollBar != NULL
		&&	pScrollBar->GetSafeHwnd() != NULL
		&&	pScrollBar->GetSafeHwnd() == m_wndSliderV.GetSafeHwnd()
		)
	{
		int nPos = m_wndSliderV.GetPos();
		if( nPos != DefaultRowHeightGet() )
			DefaultRowHeightSet( nPos );
		return;
	}
	CExtPPVW < CExtGridWnd > :: OnVScroll( nSBCode, nPos, pScrollBar );
}

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if( ! CExtPPVW < CExtGridWnd > :: PreCreateWindow( cs ) )
	{
		ASSERT( FALSE );
		return FALSE;
	}
	cs.style &= ~(WS_BORDER);
	cs.style |= WS_CLIPSIBLINGS|WS_CLIPCHILDREN;
	cs.dwExStyle &= ~(WS_EX_STATICEDGE|WS_EX_CLIENTEDGE);
	return TRUE;
}

void CChildView::OnCmdFitAllColumns() 
{
LONG nColCount = ColumnCountGet();
	if( nColCount == 0L )
		return;
INT nRealExtent = 0L, nRequiredExtent = OnSwGetClientRect().Width();
LONG nColNo;
	for( nColNo = 0L; nColNo < nColCount; nColNo++ )
	{
		CExtGridCell * pCell = GridCellGetOuterAtTop( nColNo, 0L );
		ASSERT_VALID( pCell );
		INT nColExtentNormal = 0L;
		if( ! pCell->ExtentGet(nColExtentNormal) )
			return;
		nRealExtent += nColExtentNormal;
	} // for( nColNo = 0L; nColNo < nColCount; nColNo++ )
	if( nRealExtent == nRequiredExtent )
		return;
double	lfRealExtent = double(nRealExtent),
		lfRequiredExtent(nRequiredExtent);
double lfDelta =
		(lfRequiredExtent - lfRealExtent)
		/ ( double(nColCount) );
INT nDelta = INT(lfDelta);
	if( nDelta == 0L )
		nDelta = (lfDelta < 0.0) ? (-1) : 1;
INT nExtentDone = 0L;
	for( nColNo = 0L; nColNo < nColCount; nColNo++ )
	{
		CExtGridCell * pCell = GridCellGetOuterAtTop( nColNo, 0L );
		ASSERT_VALID( pCell );
		INT nColExtentNormal = 0L, nColExtentMin = 0L, nColExtentMax = 0L;
		VERIFY( pCell->ExtentGet(nColExtentNormal) );
		VERIFY( pCell->ExtentGet(nColExtentMin,-1) );
		VERIFY( pCell->ExtentGet(nColExtentMax,1) );
		if( nColExtentMin == nColExtentMax )
			continue;
		LONG nLocalDelta = nDelta;
		if( nLocalDelta < 0L )
		{
			if( nColExtentNormal + nLocalDelta < nColExtentMin )
				nLocalDelta = nColExtentMin - nColExtentNormal;
		} // if( nLocalDelta < 0L )
		else
		{
			if( nColExtentNormal + nLocalDelta > nColExtentMax )
				nLocalDelta = nColExtentMax - nColExtentNormal;
		} // else from if( nLocalDelta < 0L )
		nExtentDone += nLocalDelta;
		nColExtentNormal += nLocalDelta;
		VERIFY( pCell->ExtentSet(nColExtentNormal) );
	} // for( nColNo = 0L; nColNo < nColCount; nColNo++ )
INT nRest = nRealExtent - nRequiredExtent + nExtentDone;
	if( nRest == 0L )
	{
		OnSwUpdateScrollBars();
		OnSwDoRedraw();
		return;
	} // if( nRest == 0L )
	if( nRest < 0 )
	{
		nRest = -nRest;
		nDelta = 1;
	} // if( nRest < 0 )
	else
		nDelta = -1;
	for( ; nRest != 0; )
	{
		
		LONG nColCountLim = 0L;
		for( nColNo = 0L; nColNo < nColCount; nColNo++ )
		{
			CExtGridCell * pCell = GridCellGetOuterAtTop( nColNo, 0L );
			ASSERT_VALID( pCell );
			INT nColExtentNormal = 0L, nColExtentMin = 0L, nColExtentMax = 0L;
			VERIFY( pCell->ExtentGet(nColExtentNormal) );
			VERIFY( pCell->ExtentGet(nColExtentMin,-1) );
			VERIFY( pCell->ExtentGet(nColExtentMax,1) );
			if( nColExtentMin == nColExtentMax )
			{
				nColCountLim++;
				continue;
			}
			if( nDelta < 0L )
			{
				if( nColExtentNormal == nColExtentMin )
				{
					nColCountLim++;
					continue;
				}
			} // if( nDelta < 0L )
			else
			{
				if( nColExtentNormal == nColExtentMax )
				{
					nColCountLim++;
					continue;
				}
			} // else from if( nDelta < 0L )
			nRest --;
			nColExtentNormal += nDelta;
			VERIFY( pCell->ExtentSet(nColExtentNormal) );
			if( nRest == 0 )
				break;
		} // for( nColNo = 0L; nColNo < nColCount; nColNo++ )
		if( nColCountLim == nColCount )
			break;
	} // for( ; nRest != 0; )
	OnSwUpdateScrollBars();
	OnSwDoRedraw();
}
void CChildView::OnUpdateCmdFitAllColumns(CCmdUI* pCmdUI) 
{
LONG nColCount = ColumnCountGet();
	if( nColCount == 0L )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
INT nRealExtent = 0L, nRequiredExtent = OnSwGetClientRect().Width();
	for( LONG nColNo = 0L; nColNo < nColCount; nColNo++ )
	{
		CExtGridCell * pCell = GridCellGetOuterAtTop( nColNo, 0L );
		ASSERT_VALID( pCell );
		INT nColExtent = 0L;
		if( ! pCell->ExtentGet(nColExtent) )
		{
			pCmdUI->Enable( FALSE );
			return;
		}
		nRealExtent += nColExtent;
	} // for( LONG nColNo = 0L; nColNo < nColCount; nColNo++ )
	if( nRealExtent == nRequiredExtent )
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	pCmdUI->Enable( TRUE );
}

void CChildView::OnCmdNavigateTop() 
{
	SendMessage(
		WM_VSCROLL,
		SB_TOP,
		LPARAM(GetScrollBarCtrl(SB_VERT)->GetSafeHwnd())
		);
}
void CChildView::OnUpdateCmdNavigateTop(CCmdUI* pCmdUI) 
{
	if( ! m_AdoDP.HaveRecordset() )
	{
		pCmdUI->Enable( FALSE );
		return;
	} // if( ! m_AdoDP.HaveRecordset() )
LONG nScrollPosV = ScrollPos32Get(SB_VERT);
	pCmdUI->Enable( ( nScrollPosV > 0L ) ? TRUE : FALSE );
}

void CChildView::OnCmdNavigateBottom() 
{
	SendMessage(
		WM_VSCROLL,
		SB_BOTTOM,
		LPARAM(GetScrollBarCtrl(SB_VERT)->GetSafeHwnd())
		);
}
void CChildView::OnUpdateCmdNavigateBottom(CCmdUI* pCmdUI) 
{
	if( ! m_AdoDP.HaveRecordset() )
	{
		pCmdUI->Enable( FALSE );
		return;
	} // if( ! m_AdoDP.HaveRecordset() )
LONG nScrollPosV = ScrollPos32Get(SB_VERT);
LONG nScrollLimitV = ScrollLimit32Get(SB_VERT);
	pCmdUI->Enable( ( nScrollPosV < nScrollLimitV ) ? TRUE : FALSE );
}

void CChildView::OnCmdNavigatePageUp() 
{
	SendMessage(
		WM_VSCROLL,
		SB_PAGEUP,
		LPARAM(GetScrollBarCtrl(SB_VERT)->GetSafeHwnd())
		);
}
void CChildView::OnUpdateCmdNavigatePageUp(CCmdUI* pCmdUI) 
{
	if( ! m_AdoDP.HaveRecordset() )
	{
		pCmdUI->Enable( FALSE );
		return;
	} // if( ! m_AdoDP.HaveRecordset() )
LONG nScrollPosV = ScrollPos32Get(SB_VERT);
	pCmdUI->Enable( ( nScrollPosV > 0L ) ? TRUE : FALSE );
}

void CChildView::OnCmdNavigatePageDown() 
{
	SendMessage(
		WM_VSCROLL,
		SB_PAGEDOWN,
		LPARAM(GetScrollBarCtrl(SB_VERT)->GetSafeHwnd())
		);
}
void CChildView::OnUpdateCmdNavigatePageDown(CCmdUI* pCmdUI) 
{
	if( ! m_AdoDP.HaveRecordset() )
	{
		pCmdUI->Enable( FALSE );
		return;
	} // if( ! m_AdoDP.HaveRecordset() )
LONG nScrollPosV = ScrollPos32Get(SB_VERT);
LONG nScrollLimitV = ScrollLimit32Get(SB_VERT);
	pCmdUI->Enable( ( nScrollPosV < nScrollLimitV ) ? TRUE : FALSE );
}

void CChildView::OnCmdNavigateFocus() 
{
CPoint ptFocus = FocusGet();
	if( ptFocus.x < 0L || ptFocus.y < 0L )
		return;
LONG	nColFirst = 0L, nColLast = 0L, nColFirstOffset = 0L,
		nRowFirst = 0L, nRowLast = 0L, nRowFirstOffset = 0L;
	OnGbwQueryVisibleColumnRange(
		nColFirst,
		nColLast,
		nColFirstOffset
		);
	OnGbwQueryVisibleRowRange(
		nRowFirst,
		nRowLast,
		nRowFirstOffset
		);
	if(		nColFirst > nColLast
		||	nRowFirst > nRowLast
		)
		return;
	if(		nColFirst >= ptFocus.x
		||	nColLast <= ptFocus.x
		)
		EnsureVisibleColumn( ptFocus.x );
	if(		nRowFirst >= ptFocus.y
		||	nRowLast <= ptFocus.y
		)
		EnsureVisibleRow( ptFocus.y );
}
void CChildView::OnUpdateCmdNavigateFocus(CCmdUI* pCmdUI) 
{
	if( (!m_AdoDP.HaveRecordset()) || m_AdoDP.RsIsVirtualMode() )
	{
		pCmdUI->Enable( FALSE );
		return;
	} // if( (!m_AdoDP.HaveRecordset()) || m_AdoDP.RsIsVirtualMode() )
CPoint ptFocus = FocusGet();
	if( ptFocus.x < 0L || ptFocus.y < 0L )
	{
		pCmdUI->Enable( FALSE );
		return;
	} // if( ptFocus.x < 0L || ptFocus.y < 0L )
LONG	nColFirst = 0L, nColLast = 0L, nColFirstOffset = 0L,
		nRowFirst = 0L, nRowLast = 0L, nRowFirstOffset = 0L;
	OnGbwQueryVisibleColumnRange(
		nColFirst,
		nColLast,
		nColFirstOffset
		);
	OnGbwQueryVisibleRowRange(
		nRowFirst,
		nRowLast,
		nRowFirstOffset
		);
	if(		nColFirst > nColLast
		||	nRowFirst > nRowLast
		)
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	if(		nColFirst <= ptFocus.x
		&&	nColLast >= ptFocus.x
		&&	nRowFirst <= ptFocus.y
		&&	nRowLast >= ptFocus.y
		)
	{
		pCmdUI->Enable( FALSE );
		return;
	}
	pCmdUI->Enable( TRUE );
}

void CChildView::OnQueryAdoSmall() 
{
	GetParentFrame()->SendMessage( WM_COMMAND, ID_QUERY_ADO );
}
void CChildView::OnUpdateQueryAdoSmall(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable();
}

void CChildView::OnCloseAdoRecordsetSmall() 
{
	m_AdoDP.CloseAdoRecordset();
	SiwFireCacheChanging( 0L, 0L );
}
void CChildView::OnUpdateCloseAdoRecordsetSmall(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( m_AdoDP.HaveRecordset() ? TRUE : FALSE );
}

void CChildView::OnCmdShowGridLines() 
{
bool bGridLines = GridLinesHorzGet();
	GridLinesHorzSet( !bGridLines, false );
	GridLinesVertSet( !bGridLines, true );
}

void CChildView::OnUpdateCmdShowGridLines(CCmdUI* pCmdUI) 
{
	if( ! m_AdoDP.HaveRecordset() )
	{
		pCmdUI->Enable( FALSE );
		return;
	} // if( ! m_AdoDP.HaveRecordset() )
	pCmdUI->Enable( TRUE );
	pCmdUI->SetCheck( GridLinesHorzGet() ? TRUE : FALSE );
}

void CChildView::OnCmdShowRowHeaders() 
{
	if( OuterColumnWidthGet(true,0L) == 0L )
	{
		OuterColumnWidthSet( true, 0, 80 );
		OuterColumnWidthSet( false, 0, 12 );
	} // if( OuterColumnWidthGet(true,0L) == 0L )
	else
	{
		OuterColumnWidthSet( true, 0, 0 );
		OuterColumnWidthSet( false, 0, 0 );
	} // else from if( OuterColumnWidthGet(true,0L) == 0L )
	OnSwUpdateScrollBars();
	OnSwDoRedraw();
}

void CChildView::OnUpdateCmdShowRowHeaders(CCmdUI* pCmdUI) 
{
	if( ! m_AdoDP.HaveRecordset() )
	{
		pCmdUI->Enable( FALSE );
		return;
	} // if( ! m_AdoDP.HaveRecordset() )
	pCmdUI->Enable( TRUE );
	pCmdUI->SetCheck( (OuterColumnWidthGet(true,0L)!=0L) ? TRUE : FALSE );
}

void CChildView::OnUseDynamicColumnResizing() 
{
	if( (SiwGetStyle()&__EGBS_DYNAMIC_RESIZING_H) == 0L )
		SiwModifyStyle( __EGBS_DYNAMIC_RESIZING_H, 0L, false );
	else
		SiwModifyStyle( 0L, __EGBS_DYNAMIC_RESIZING_H, false );
}
void CChildView::OnUpdateUseDynamicColumnResizing(CCmdUI* pCmdUI) 
{
	if( ! m_AdoDP.HaveRecordset() )
	{
		pCmdUI->Enable( FALSE );
		return;
	} // if( ! m_AdoDP.HaveRecordset() )
	pCmdUI->Enable( TRUE );
	pCmdUI->SetCheck( ( (SiwGetStyle()&__EGBS_DYNAMIC_RESIZING_H) != 0L ) ? TRUE : FALSE );
}

void CChildView::OnUseThumbTrackingHorizontal() 
{
	if( (SiwGetStyle()&__ESIS_DISABLE_THUMBTRACK_H) == 0L )
		SiwModifyStyle( __ESIS_DISABLE_THUMBTRACK_H, 0L, false );
	else
		SiwModifyStyle( 0L, __ESIS_DISABLE_THUMBTRACK_H, false );
}
void CChildView::OnUpdateUseThumbTrackingHorizontal(CCmdUI* pCmdUI) 
{
	if( ! m_AdoDP.HaveRecordset() )
	{
		pCmdUI->Enable( FALSE );
		return;
	} // if( ! m_AdoDP.HaveRecordset() )
	pCmdUI->Enable( TRUE );
	pCmdUI->SetCheck( ( (SiwGetStyle()&__ESIS_DISABLE_THUMBTRACK_H) == 0L ) ? TRUE : FALSE );
}

void CChildView::OnUseThumbTrackingVertical() 
{
	if( (SiwGetStyle()&__ESIS_DISABLE_THUMBTRACK_V) == 0L )
		SiwModifyStyle( __ESIS_DISABLE_THUMBTRACK_V, 0L, false );
	else
		SiwModifyStyle( 0L, __ESIS_DISABLE_THUMBTRACK_V, false );
}
void CChildView::OnUpdateUseThumbTrackingVertical(CCmdUI* pCmdUI) 
{
	if( ! m_AdoDP.HaveRecordset() )
	{
		pCmdUI->Enable( FALSE );
		return;
	} // if( ! m_AdoDP.HaveRecordset() )
	pCmdUI->Enable( TRUE );
	pCmdUI->SetCheck( ( (SiwGetStyle()&__ESIS_DISABLE_THUMBTRACK_V) == 0L ) ? TRUE : FALSE );
}
