// ChildView.h : interface of the CChildView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CHILDVIEW_H__3C598774_58D7_4703_A198_95CF22226AFC__INCLUDED_)
#define AFX_CHILDVIEW_H__3C598774_58D7_4703_A198_95CF22226AFC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXPRIV_H__
	#include <AfxPriv.h>
#endif

/////////////////////////////////////////////////////////////////////////////
// CFormattedException

class CFormattedException : public CException
{
	CExtSafeString m_strErrorDescription;
public:
	CFormattedException(
		LPCTSTR strErrorDescription
		)
		: CException( TRUE )
		, m_strErrorDescription( strErrorDescription )
	{
		ASSERT( m_strErrorDescription.GetLength() > 0 );
	}
#ifdef _DEBUG
	virtual void AssertValid() const
	{
		CException::AssertValid();
		ASSERT( m_strErrorDescription.GetLength() > 0 );
	}
#endif // _DEBUG
	virtual BOOL GetErrorMessage(
		LPTSTR lpszError,
		UINT nMaxError,
		PUINT pnHelpContext = NULL
		)
	{
		ASSERT_VALID( this );
		if( lpszError == NULL || nMaxError < 2 )
			return FALSE;
		if( pnHelpContext != NULL )
			*pnHelpContext = 0;
		__EXT_MFC_STRNCPY(
			lpszError,
			_tcslen(lpszError) + 1,
			LPCTSTR( m_strErrorDescription ),
			nMaxError
			);
		return TRUE;
	}
}; // class CFormattedException

#define __COM_SECTION_TRY_BEGIN \
	try \
	{

#define __COM_SECTION_TRY_END \
	} \
	catch( _com_error & _ce ) \
	{ \
		HRESULT hr = _ce.Error(); \
		WORD wCode = _ce.WCode(); \
		_bstr_t bstrDescription = _ce.Description(); \
		_bstr_t bstrHelpFile = _ce.HelpFile(); \
		DWORD dwHelpContext = _ce.HelpContext(); \
		_bstr_t bstrSource = _ce.Source(); \
		LPCTSTR strDescription = bstrDescription; \
		if( strDescription == NULL ) \
			strDescription = _T(""); \
		LPCTSTR strHelpFile = bstrHelpFile; \
		if( strHelpFile == NULL ) \
			strHelpFile = _T(""); \
		LPCTSTR strSource = bstrSource; \
		if( strSource == NULL ) \
			strSource = _T(""); \
		CExtSafeString strRethrow; \
		strRethrow.Format( \
			_T("COM error caught (hr=%d=0x%08X, wCode=%d, description=\"%s\", helpfile=\"%s\", helpctx=%d=0x%08X, source=\"%s\" )"), \
			hr, hr, int(wCode), strDescription, strHelpFile, dwHelpContext, dwHelpContext, strSource \
			); \
		throw new CFormattedException( LPCTSTR(strRethrow) ); \
	} \
	catch( CException * pXcept ) \
	{ \
		pXcept; \
		throw; \
	} \
	catch( ... ) \
	{ \
		throw new CFormattedException( _T("unknown error") ); \
	}

/////////////////////////////////////////////////////////////////////////////
// CAdoDataCell

class CAdoDataCell : public CExtGridCellVariant
{
	void _SyncData()
	{
		ASSERT_VALID( this );
		ModifyStyle(
			(vt != VT_BOOL)
				? 0
				: ( __EGCS_CHK_CHECK |
					( boolVal ? __EGCS_CHECKED : 0 )
				),
			__EGCS_CHK_MASK
			);
	}
public:
	DECLARE_DYNCREATE( CAdoDataCell );
	IMPLEMENT_ExtGridCell_Clone( CAdoDataCell, CExtGridCellVariant );
	CAdoDataCell(
		CExtGridDataProvider * pDataProvider = NULL
		)
		: CExtGridCellVariant( pDataProvider )
	{
		_SyncData();
	}
	CAdoDataCell( const CExtGridCellVariant & other )
		: CExtGridCellVariant( other )
	{
		_SyncData();
	}
	CAdoDataCell( const CExtGridCell & other )
		: CExtGridCellVariant( other )
	{
		_SyncData();
	}
	CAdoDataCell(
		const VARIANT & other,
		CExtGridDataProvider * pDataProvider = NULL
		)
		: CExtGridCellVariant( other, pDataProvider )
	{
		_SyncData();
	}
	virtual void Assign( const CExtGridCell & other )
	{
		CExtGridCellVariant::Assign( other );
		_SyncData();
	}
	virtual void TextGet( CExtSafeString & strCopy ) const
	{
		ASSERT_VALID( this );
		if( vt == VT_BOOL )
		{
			strCopy.Empty();
			return;
		} // if( vt == VT_BOOL )
		CExtGridCellVariant::TextGet( strCopy );
	}
}; // class CAdoDataCell

/////////////////////////////////////////////////////////////////////////////
// CAdoDataCell_Combobox
class CAdoDataCell_Combobox : public CExtGridCellComboBox
{
private:
	CStringArray m_arrsCustomItemdata;
	long* m_arrlCustomItemdata;
	CString m_sTest;
public:
	DECLARE_DYNCREATE( CAdoDataCell_Combobox );
	IMPLEMENT_ExtGridCell_Clone( CAdoDataCell_Combobox, CExtGridCellComboBox);

/////////////////////////////////////////////////////////////////////////
// BEGIN: ADDED BY PROF-UIS TECH SUPPORT
private:
	void _AssignOwnPropertiesOnly( const CExtGridCell & other )
	{
		ASSERT_VALID( this );
		CAdoDataCell_Combobox * pSame =
			DYNAMIC_DOWNCAST(
				CAdoDataCell_Combobox,
				( const_cast < CExtGridCell * > ( & other ) )
				);
		if( pSame != NULL )
		{
			// perform assignment from the same cell type
			m_sTest = pSame->m_sTest;
			m_arrlCustomItemdata = pSame->m_arrlCustomItemdata;
			m_arrsCustomItemdata.RemoveAll();
			m_arrsCustomItemdata.Append( pSame->m_arrsCustomItemdata );
		}
		else
		{
			// reset own data
			m_sTest.Empty();
			m_arrlCustomItemdata = NULL; // may be you need to invoke free() or delete
			m_arrsCustomItemdata.RemoveAll();
		}
	}
public:
// END: ADDED BY PROF-UIS TECH SUPPORT
/////////////////////////////////////////////////////////////////////////
	
	//* Konstruktor / Destruktor *
	CAdoDataCell_Combobox(
		CExtGridDataProvider * pDataProvider = NULL
		)
		: CExtGridCellComboBox( pDataProvider )
/////////////////////////////////////////////////////////////////////////
// BEGIN: ADDED BY PROF-UIS TECH SUPPORT
		, m_arrlCustomItemdata( NULL )
// END: ADDED BY PROF-UIS TECH SUPPORT
/////////////////////////////////////////////////////////////////////////
	{	
	}
	
	//* Sonstige Funktionen *
	void SetCustomItemData () {		
		m_sTest = "TEST";
	}

/////////////////////////////////////////////////////////////////////////
// BEGIN: REMOVED BY PROF-UIS TECH SUPPORT - message boxes must not be displayed here
//	virtual bool OnPopupListBoxItemClick (
//		CExtPopupInplaceListBox & wndListBox,
//		CExtGridCell::TrackCellStateInfo_t & _tcsi
//		) 
//	{
//		AfxMessageBox(m_sTest);
//		return CExtGridCell::OnPopupListBoxItemClick(wndListBox, _tcsi);
//	}
// END: REMOVED BY PROF-UIS TECH SUPPORT - message boxes must not be displayed here
/////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////
// BEGIN: ADDED BY PROF-UIS TECH SUPPORT - correct selection changing handler
	virtual bool OnPopupListBoxSelEndOK(
		CExtPopupInplaceListBox & wndListBox,
		CExtGridCell::TrackCellStateInfo_t & _tcsi
		)
	{
		ASSERT_VALID( this );
		bool bRetVal = CExtGridCellComboBox::OnPopupListBoxSelEndOK( wndListBox, _tcsi );
		::AfxMessageBox( m_sTest );
		return bRetVal;
	}
// END: ADDED BY PROF-UIS TECH SUPPORT - correct selection changing handler
/////////////////////////////////////////////////////////////////////////

	virtual void Assign( const CExtGridCell & other )
	{
/////////////////////////////////////////////////////////////////////////
// BEGIN: ADDED BY PROF-UIS TECH SUPPORT
		_AssignOwnPropertiesOnly( other );
// END: ADDED BY PROF-UIS TECH SUPPORT
/////////////////////////////////////////////////////////////////////////
		CExtGridCellComboBox::Assign( other );	
	}
}; // class CAdoDataCell_Combobox

/////////////////////////////////////////////////////////////////////////////
// CAdoDataProvider

class CAdoDataProvider : public CExtGridDataProviderRecordset
{
protected:
	CExtGridDataProviderMemory m_Cache;
	LONG m_nRecordsCount, m_nFieldsCount;
	bool m_bVirtualMode:1;
	ADODB::_RecordsetPtr m_objAdoRS;
public:
	DECLARE_DYNAMIC( CAdoDataProvider );
	CAdoDataProvider()
		: m_bVirtualMode( false )
		, m_nRecordsCount( 0L )
		, m_nFieldsCount( 0L )
	{
		m_pOther = &m_Cache;
	}
	~CAdoDataProvider()
	{
		if( NULL != m_objAdoRS )
			m_objAdoRS.Release();
	}
	bool HaveRecordset() const
	{
		return (m_objAdoRS != NULL) ? true : false;
	}
	void CloseAdoRecordset()
	{
		try
		{
			m_bHeaderInitialized = false;
			m_bVirtualMode = false;
			m_nFieldsCount = 0L;
			m_nRecordsCount = 0L;
			m_sci.Empty();
			if( NULL != m_objAdoRS )
				m_objAdoRS.Release();
			ULONG nCacheReservedColCount = 0L, nCacheReservedRowCount = 0L;
			m_Cache.CacheReservedCountsGet( &nCacheReservedColCount, &nCacheReservedRowCount );
			ULONG nCachedRowCount = m_Cache.RowCountGet();
			if( nCachedRowCount > nCacheReservedRowCount )
				m_Cache.RowRemove( nCacheReservedRowCount, nCachedRowCount-nCacheReservedRowCount );
			else if( nCachedRowCount < nCacheReservedRowCount )
				m_Cache.RowInsert( nCacheReservedRowCount, nCacheReservedRowCount-nCachedRowCount );
			ULONG nCachedColCount = m_Cache.ColumnCountGet();
			if( nCachedColCount > nCacheReservedColCount )
				m_Cache.ColumnRemove( nCacheReservedColCount, nCachedColCount-nCacheReservedColCount );
			else if( nCachedColCount < nCacheReservedColCount )
				m_Cache.ColumnInsert( nCacheReservedColCount, nCacheReservedColCount-nCachedColCount );
		} // try
		catch( ... )
		{
		} // catch( ... )
	}
	void SetAdoRecordset(
		ADODB::_RecordsetPtr & objAdoRS
		)
	{
		try
		{
			m_bHeaderInitialized = false;
			m_sci.Empty();
			ASSERT( NULL != objAdoRS );
			if( NULL != m_objAdoRS )
				m_objAdoRS.Release();
			ULONG nCacheReservedColCount = 0L, nCacheReservedRowCount = 0L;
			m_Cache.CacheReservedCountsGet( &nCacheReservedColCount, &nCacheReservedRowCount );
			ULONG nCachedRowCount = m_Cache.RowCountGet();
			if( nCachedRowCount > nCacheReservedRowCount )
				m_Cache.RowRemove( nCacheReservedRowCount, nCachedRowCount-nCacheReservedRowCount );
			else if( nCachedRowCount < nCacheReservedRowCount )
				m_Cache.RowInsert( nCacheReservedRowCount, nCacheReservedRowCount-nCachedRowCount );
			ULONG nCachedColCount = m_Cache.ColumnCountGet();
			if( nCachedColCount > nCacheReservedColCount )
				m_Cache.ColumnRemove( nCacheReservedColCount, nCachedColCount-nCacheReservedColCount );
			else if( nCachedColCount < nCacheReservedColCount )
				m_Cache.ColumnInsert( nCacheReservedColCount, nCacheReservedColCount-nCachedColCount );
			m_objAdoRS = objAdoRS;
			ADODB::CursorTypeEnum nCursorTypeReal = m_objAdoRS->CursorType;
			if( nCursorTypeReal == ADODB::adOpenStatic )
			{
				m_nRecordsCount = (LONG) m_objAdoRS->RecordCount;
				ASSERT( m_nRecordsCount >= 0L );
				m_bVirtualMode = false;
			}
			else
			{
				m_nRecordsCount = -1L;
				m_bVirtualMode = true;
			}
			m_nFieldsCount = m_objAdoRS->Fields->Count;
			ASSERT( m_nFieldsCount > 0L );
		
			if(		nCacheReservedRowCount > 0
				&&	m_nRowNoHeader >= 0L
				&&	m_nRowNoHeader < nCacheReservedRowCount
				)
			{ // re-cache header
				ASSERT( nCacheReservedColCount == m_Cache.ColumnCountGet() );
				m_Cache.ColumnInsert( nCacheReservedColCount, m_nFieldsCount );
				RsCacheRow(
					nCacheReservedColCount,
					m_nRowNoHeader,
					true
					);
				m_bHeaderInitialized = true;
			} // re-cache header
		} // try
		catch( _com_error & _ce )
		{
			_bstr_t bstrDescription = _ce.Description();
			bstrDescription;
			_bstr_t bstrHelpFile = _ce.HelpFile();
			bstrHelpFile;
			ASSERT( FALSE );
		} // catch( _com_error & )
		catch( ... )
		{
			ASSERT( FALSE );
		} // catch( ... )
	}
#ifdef _DEBUG
	virtual void AssertValid() const
	{
		CExtGridDataProviderRecordset::AssertValid();
		//ASSERT( NULL != m_objAdoRS );
	}
#endif // _DEBUG
	virtual void RsSeekToFirst()
	{
		ASSERT_VALID( this );
		ASSERT_VALID( m_pOther );
		if( m_objAdoRS == NULL )
			return;
		ASSERT( ( ! ( RsIsBOF() && RsIsEOF() ) ) );
		__COM_SECTION_TRY_BEGIN
			m_objAdoRS->MoveFirst();
		__COM_SECTION_TRY_END
	}
	virtual void RsSeekToLast()
	{
		ASSERT_VALID( this );
		ASSERT_VALID( m_pOther );
		if( m_objAdoRS == NULL )
			return;
		ASSERT( ( ! ( RsIsBOF() && RsIsEOF() ) ) );
		__COM_SECTION_TRY_BEGIN
			m_objAdoRS->MoveLast();
		__COM_SECTION_TRY_END
	}
	virtual void RsSeekToNext()
	{
		ASSERT_VALID( this );
		ASSERT_VALID( m_pOther );
		if( m_objAdoRS == NULL )
			return;
		ASSERT( ( ! RsIsEOF() ) );
		__COM_SECTION_TRY_BEGIN
			m_objAdoRS->MoveNext();
		__COM_SECTION_TRY_END
	}
	virtual void RsSeekToPrevious()
	{
		ASSERT_VALID( this );
		ASSERT_VALID( m_pOther );
		if( m_objAdoRS == NULL )
			return;
		ASSERT( ( ! RsIsBOF() ) );
		__COM_SECTION_TRY_BEGIN
			m_objAdoRS->MovePrevious();
		__COM_SECTION_TRY_END
	}
	virtual void RsSeekFromStart( LONG nPos )
	{
		ASSERT_VALID( this );
		ASSERT_VALID( m_pOther );
		if( m_objAdoRS == NULL )
			return;
		ASSERT( ( ! ( RsIsBOF() && RsIsEOF() ) ) );
		// must not be invoked in virtual mode
		ASSERT( ! RsIsVirtualMode() );
		__COM_SECTION_TRY_BEGIN
			m_objAdoRS->Move(
				nPos,
				_variant_t( long(ADODB::adBookmarkFirst),VT_I4 )
				);
		__COM_SECTION_TRY_END
	}
	virtual void RsSeekFromEnd( LONG nPos )
	{
		ASSERT_VALID( this );
		ASSERT_VALID( m_pOther );
		if( m_objAdoRS == NULL )
			return;
		ASSERT( ( ! ( RsIsBOF() && RsIsEOF() ) ) );
		// must not be invoked in virtual mode
		ASSERT( ! RsIsVirtualMode() );
		__COM_SECTION_TRY_BEGIN
			m_objAdoRS->Move(
				nPos,
				_variant_t( long(ADODB::adBookmarkLast),VT_I4 )
				);
		__COM_SECTION_TRY_END
	}
	virtual void RsSeekFromCurrent( LONG nPos )
	{
		ASSERT_VALID( this );
		ASSERT_VALID( m_pOther );
		if( m_objAdoRS == NULL )
			return;
		ASSERT( ( ! ( RsIsBOF() && RsIsEOF() ) ) );
		// must not be invoked in virtual mode
		ASSERT( ! RsIsVirtualMode() );
		__COM_SECTION_TRY_BEGIN
			m_objAdoRS->Move(
				nPos,
				_variant_t( long(ADODB::adBookmarkCurrent),VT_I4 )
				);
		__COM_SECTION_TRY_END
	}
	virtual bool RsIsBOF()
	{
		ASSERT_VALID( this );
		ASSERT_VALID( m_pOther );
		if( m_objAdoRS == NULL )
			return true;
		bool bRetVal = true;
		__COM_SECTION_TRY_BEGIN
			bRetVal = m_objAdoRS->ADOBOF ? true : false;
		__COM_SECTION_TRY_END
		return bRetVal;
	}
	virtual bool RsIsEOF()
	{
		ASSERT_VALID( this );
		ASSERT_VALID( m_pOther );
		if( m_objAdoRS == NULL )
			return true;
		bool bRetVal = false;
		__COM_SECTION_TRY_BEGIN
			bRetVal = m_objAdoRS->ADOEOF ? true : false;
		__COM_SECTION_TRY_END
		return bRetVal;
	}
	virtual bool RsIsVirtualMode()
	{
		ASSERT_VALID( this );
		ASSERT_VALID( m_pOther );
		if( m_objAdoRS == NULL )
			return false;
		return m_bVirtualMode;
	}
	virtual LONG RsFieldsCount()
	{
		ASSERT_VALID( this );
		ASSERT_VALID( m_pOther );
		if( m_objAdoRS == NULL )
			return 0L;
		if( m_nFieldsCount > 0L )
			return m_nFieldsCount;
		__COM_SECTION_TRY_BEGIN
			m_nFieldsCount = m_objAdoRS->Fields->Count;
		__COM_SECTION_TRY_END
		ASSERT( m_nFieldsCount >= 0L );
		return m_nFieldsCount;
	}
	virtual LONG RsRecordsCount()
	{
		ASSERT_VALID( this );
		ASSERT_VALID( m_pOther );
		if( m_objAdoRS == NULL )
			return 0L;
		// must not be invoked in virtual mode
		ASSERT( ! RsIsVirtualMode() );
		ASSERT( m_nRecordsCount >= 0L );
		return m_nRecordsCount;
	}
	virtual void RsCacheRow(
		ULONG nCacheColOffset,
		ULONG nCacheRowNo,
		bool bHeader
		)
	{
		ASSERT_VALID( this );
		ASSERT_VALID( m_pOther );
		if( m_objAdoRS == NULL )
			return;
		LONG nColCount = RsFieldsCount();
		__COM_SECTION_TRY_BEGIN
			if( ! bHeader )
			{ // setup all the row header cells at left/right
				ULONG nColCountReserved = 0L;
				CacheReservedCountsGet(
					&nColCountReserved,
					NULL
					);
				if( nColCountReserved > 0L )
				{
					for( LONG nColNo = 0; nColNo < LONG(nColCountReserved); nColNo++ )
					{ // init all header cells at left/right
						CExtGridCellHeader _cellHeader( m_pOther );
						_cellHeader.ModifyStyle(
							__EGCS_TA_HORZ_RIGHT|__EGCS_HDR_ROW_COLUMN_NUMBER
							|__EGCS_HDR_FOCUS_ARROW_RESERVE_SPACE|__EGCS_HDR_FOCUS_ARROW_DISPLAY
							);
						VERIFY(
							m_pOther->CellRangeSet(
								nColNo,
								nCacheRowNo,
								1,
								1,
								&_cellHeader
								)
							);
					} // init all header cells at left/right
				} // if( nColCountReserved > 0L )
			} // setup all the row header cells at left/right
			for( LONG nColNo = 0; nColNo < nColCount; nColNo++ )
			{
				if( bHeader )
				{
					_bstr_t bstrName = m_objAdoRS->Fields->Item[LONG(nColNo)]->GetName();
					USES_CONVERSION;
					CExtGridCellHeader _cellHeader( m_pOther );
					LPCTSTR strName = OLE2CT(bstrName);
					_cellHeader.TextSet( strName );
					_cellHeader.ExtentSet( 100, 0 );
					VERIFY(
						m_pOther->CellRangeSet(
							nColNo + nCacheColOffset,
							nCacheRowNo,
							1,
							1,
							&_cellHeader
							)
						);
					ULONG nRowCountReserved = 0L;
					CacheReservedCountsGet(
						NULL,
						&nRowCountReserved
						);
				} // if( bHeader )
				else
				{
					variant_t vv = m_objAdoRS->Fields->Item[nColNo]->Value;
					//CAdoDataCell _cellAdoVariant( vv, m_pOther );
					CAdoDataCell_Combobox _cellAdoVariant( m_pOther );
					
					//_cellAdoVariant.ModifyStyle( __EGCS_READ_ONLY );
					/*if( _cellAdoVariant.vt == VT_BOOL )
						_cellAdoVariant.ModifyStyle( __EGCS_ICA_HORZ_CENTER );
					*/

					_cellAdoVariant.SetCustomItemData();

					_cellAdoVariant.InsertString( _T("Test1") );
					_cellAdoVariant.InsertString( _T("Test2") );
					_cellAdoVariant.InsertString( _T("Test3") );
					_cellAdoVariant.InsertString( _T("Test4") );

					_cellAdoVariant.ModifyStyle(0, __EGCS_READ_ONLY);
					_cellAdoVariant.ModifyStyleEx(0, __EGCS_EX_BUTTON_DROPDOWN_DISABLED);
					_cellAdoVariant.ModifyStyleEx(0, __EGCS_EX_INVISIBLE);
					_cellAdoVariant.ModifyStyle(__EGCS_NO_INPLACE_CONTROL);

/////////////////////////////////////////////////////////////////////////
// BEGIN: ADDED BY PROF-UIS TECH SUPPORT
if( vv.vt == VT_BSTR )
{
	USES_CONVERSION;
	_cellAdoVariant.TextSet( OLE2CT( vv.bstrVal ) );
}
// END: ADDED BY PROF-UIS TECH SUPPORT
/////////////////////////////////////////////////////////////////////////

					VERIFY(
						m_pOther->CellRangeSet(
							nColNo + nCacheColOffset,
							nCacheRowNo,
							1,
							1,
							&_cellAdoVariant
							)
						);
				} // else from if( bHeader )
			} // for( LONG nColNo = 0; nColNo < nColCount; nColNo++ )
		__COM_SECTION_TRY_END
	}
}; // class CAdoDataProvider

/////////////////////////////////////////////////////////////////////////////
// CInplaceToolbarWnd window

class CInplaceToolbarWnd : public CExtToolControlBar
{
	class TinyButton : public CExtBarButton
	{
	public:
		TinyButton(
			CExtToolControlBar * pBar = NULL,
			UINT nCmdID = ID_SEPARATOR,
			UINT nStyle = 0
			)
			: CExtBarButton(
				pBar,
				nCmdID,
				nStyle
				)
		{
		}
		virtual CSize CalculateLayout(
			CDC & dc,
			CSize sizePreCalc,
			BOOL bHorz
			)
		{
			ASSERT_VALID( this );
			dc;
			sizePreCalc;
			bHorz;
			return CSize( 13, 13 );
		}
	}; // class TinyButton
protected:
	virtual LRESULT WindowProc(
		UINT message,
		WPARAM wParam,
		LPARAM lParam
		)
	{
		ASSERT_VALID( this );
		if( message == WM_NCCALCSIZE )
			return 0L;
		if( message == WM_SIZEPARENT )
			return 0L;
		LRESULT lResult = CExtToolControlBar::WindowProc( message, wParam, lParam );
		return lResult;
	}
	virtual CExtBarContentExpandButton * OnCreateBarRightBtn()
	{
		ASSERT_VALID( this );
		return NULL;
	}
	virtual CExtBarButton * OnCreateBarCommandBtn(
		UINT nCmdID,
		UINT nStyle = 0
		)
	{
		ASSERT_VALID( this );
		CExtBarButton * pTBB = new TinyButton( this, nCmdID, nStyle );
		ASSERT_VALID( pTBB );
		return pTBB;
	}
}; // class CInplaceToolbarWnd

/////////////////////////////////////////////////////////////////////////////
// CInplaceSliderWnd window

class CInplaceSliderWnd : public CSliderCtrl
{
protected:
	virtual LRESULT WindowProc(
		UINT message,
		WPARAM wParam,
		LPARAM lParam
		)
	{
		ASSERT_VALID( this );
		if( message == WM_MOUSEACTIVATE )
			return MA_NOACTIVATE;
		if( message == WM_SETFOCUS )
		{
			::SetFocus( ::GetParent(m_hWnd) );
			return 0L;
		}
		if( message == WM_ERASEBKGND )
			return TRUE;
		if( message == WM_NCCALCSIZE )
			return 0L;
		if( message == WM_PAINT )
		{
			CPaintDC dcPaint( this );
			CExtPaintManager::stat_ExcludeChildAreas(
				dcPaint.GetSafeHdc(),
				GetSafeHwnd()
				);
			CRect rcClient;
			GetClientRect( &rcClient );
			CExtMemoryDC dc(
				&dcPaint,
				&rcClient
				);
			if( g_PaintManager->GetCb2DbTransparentMode(this) )
				g_PaintManager->PaintDockerBkgnd( true, dc, this );
			else
				dc.FillSolidRect(
					&rcClient,
					g_PaintManager->GetColor(
						CExtPaintManager::CLR_3DFACE_OUT,
						this
						)
					);
			DWORD dwWndStyle = GetStyle();
			bool bHorz = ( (dwWndStyle&TBS_VERT) != 0 ) ? false : true;
			COLORREF clrFace = g_PaintManager->GetColor( COLOR_3DFACE, this );
			COLORREF clrHilight = g_PaintManager->GetColor( COLOR_3DHILIGHT, this );
			COLORREF clrShadow = g_PaintManager->GetColor( COLOR_3DSHADOW, this );
			CRect rcChannel;
			//CSliderCtrl::GetChannelRect( &rcChannel );
			rcChannel = rcClient;
			CRect rcThumb;
			CSliderCtrl::GetThumbRect( &rcThumb );
			if( bHorz )
			{
				rcChannel.top = rcThumb.top;
				rcChannel.bottom = rcThumb.bottom;
				rcChannel.DeflateRect(
					rcThumb.Width(),
					( rcChannel.Height() - rcThumb.Width() ) / 2
					);
			} // if( bHorz )
			else
			{
				rcChannel.left = rcThumb.left;
				rcChannel.right = rcThumb.right;
				rcChannel.DeflateRect(
					( rcChannel.Width() - rcThumb.Height() ) / 2,
					rcThumb.Height()
					);
			} // else from if( bHorz )
			dc.FillSolidRect( &rcChannel, clrFace );
			dc.Draw3dRect( &rcChannel, clrShadow, clrHilight );
			dc.FillSolidRect( &rcThumb, clrFace );
			dc.Draw3dRect( &rcThumb, clrHilight, clrShadow );
			return 0;
		} // if( message == WM_PAINT )
		LRESULT lResult = CSliderCtrl::WindowProc( message, wParam, lParam );
		return lResult;
	}
}; // class CInplaceSliderWnd

/////////////////////////////////////////////////////////////////////////////
// CChildView window

class CChildView : public CExtPPVW < CExtGridWnd >
{
// Construction
public:
	CChildView();

// Attributes
public:
	CInplaceToolbarWnd m_wndToolbarHL, m_wndToolbarHR, m_wndToolbarV;
	CInplaceSliderWnd m_wndSliderV;
	CExtScrollBar m_wndScrollBarH, m_wndScrollBarV;
	CAdoDataProvider m_AdoDP;
	virtual CExtGridDataProvider & OnGridQueryDataProvider()
	{
		ASSERT_VALID( this );
		return m_AdoDP;
	}

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CChildView)
	public:
	virtual CScrollBar* GetScrollBarCtrl(int nBar) const;
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CChildView();
	virtual INT DefaultRowHeightSet(
		INT nRowHeight,
		bool bRedraw = true
		);

	// Generated message map functions
protected:
	//{{AFX_MSG(CChildView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnCmdFitAllColumns();
	afx_msg void OnUpdateCmdFitAllColumns(CCmdUI* pCmdUI);
	afx_msg void OnCmdNavigateTop();
	afx_msg void OnUpdateCmdNavigateTop(CCmdUI* pCmdUI);
	afx_msg void OnCmdNavigateBottom();
	afx_msg void OnUpdateCmdNavigateBottom(CCmdUI* pCmdUI);
	afx_msg void OnCmdNavigatePageUp();
	afx_msg void OnUpdateCmdNavigatePageUp(CCmdUI* pCmdUI);
	afx_msg void OnCmdNavigatePageDown();
	afx_msg void OnUpdateCmdNavigatePageDown(CCmdUI* pCmdUI);
	afx_msg void OnCmdNavigateFocus();
	afx_msg void OnUpdateCmdNavigateFocus(CCmdUI* pCmdUI);
	afx_msg void OnQueryAdoSmall();
	afx_msg void OnUpdateQueryAdoSmall(CCmdUI* pCmdUI);
	afx_msg void OnCloseAdoRecordsetSmall();
	afx_msg void OnUpdateCloseAdoRecordsetSmall(CCmdUI* pCmdUI);
	afx_msg void OnCmdShowGridLines();
	afx_msg void OnUpdateCmdShowGridLines(CCmdUI* pCmdUI);
	afx_msg void OnCmdShowRowHeaders();
	afx_msg void OnUpdateCmdShowRowHeaders(CCmdUI* pCmdUI);
	afx_msg void OnUseDynamicColumnResizing();
	afx_msg void OnUpdateUseDynamicColumnResizing(CCmdUI* pCmdUI);
	afx_msg void OnUseThumbTrackingHorizontal();
	afx_msg void OnUpdateUseThumbTrackingHorizontal(CCmdUI* pCmdUI);
	afx_msg void OnUseThumbTrackingVertical();
	afx_msg void OnUpdateUseThumbTrackingVertical(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHILDVIEW_H__3C598774_58D7_4703_A198_95CF22226AFC__INCLUDED_)
